// red2.c - Definicije paketa za redove neograničenih kapaciteta.

#include "red2.h"
#include <stdio.h>
#include <stdlib.h>

Red stvori() { return (Red){NULL, NULL}; } // Stvaranje reda.

void stavi(Red *rd, int b) {               // Stavljanje broja u red.
  Elem *novi = malloc(sizeof(Elem));
  novi->broj = b; novi->sled = NULL;
  if (!rd->posl) rd->prvi = novi; else rd->posl->sled = novi;
  rd->posl = novi;
}

int uzmi(Red *rd) {                        // Uzimanje broja iz reda.
  if (!rd->prvi) exit(2);
  int b = rd->prvi->broj;
  Elem *stari = rd->prvi; rd->prvi = rd->prvi->sled; free(stari);
  if (!rd->prvi) rd->posl = NULL;
  return b;
}

_Bool prazan(Red rd) { return rd.prvi == NULL; } // Da li je red prazan?

void pisi (Red rd) {                       // Ispisivanje sadržaja reda.
  for (Elem *tek=rd.prvi; tek; tek=tek->sled) printf("%d ", tek->broj);
}

void prazni(Red *rd) {                     // Pražnjenje reda.
  while (rd->prvi) {
    Elem *stari = rd->prvi; rd->prvi = rd->prvi->sled;
    free(stari);
  }
}

void unisti(Red *rd) { prazni(rd); }       // Uništavanje reda.
