// rel_dat.h - Deklaracije paketa za obradu relativnih datoteka.

#ifndef _rel_dat_h_
#define _rel_dat_h_

#include <stdio.h>

typedef struct {
  FILE *dat;                                 // Pokazivač na datoteku.
  int   duz;                                 // Dužina zapisa.
  long  br_zap;                              // Broj zapisa u datoteci.
} Rel_dat;

Rel_dat *rd_pravi(const char *ime, int duz); // Stvaranje nove datoteke.
Rel_dat *rd_otvori(const char *ime);         // Otvaranje stare datoteke.
int rd_pisi (Rel_dat *dat, long k, const void *zap); // Upisivanje zapisa.
int rd_citaj(Rel_dat *dat, long k, void *zap);       // Čitanje zapisa.
long rd_broj_zap(Rel_dat *dat);              // Broj zapisa u datoteci.
int rd_zatvori(Rel_dat *dat);                // Zatvaranje datoteke.

#endif
